diff -crN nakedmudv1.0/src/olc/ssedit.c nakedmudv1.4/src/olc/ssedit.c
*** nakedmudv1.0/src/olc/ssedit.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/olc/ssedit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,150 ----
+ //*****************************************************************************
+ //
+ // ssedit.c
+ //
+ // the functions used for editing room/obj/mob script sets.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../socket.h"
+ #include "../world.h"
+ #include "../utils.h"
+ 
+ #include "olc.h"
+ 
+ 
+ #ifdef MODULE_SCRIPTS
+ #include "../scripts/script.h"
+ #include "../scripts/script_set.h"
+ 
+ 
+ void ssedit_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
+   LIST *scripts = scriptSetList((SCRIPT_SET *)olcGetData(olc), SCRIPT_TYPE_ANY);
+   SCRIPT_DATA *script = NULL;
+ 
+   send_to_socket(sock,
+                  "\033[H\033[J"
+ 		 "{g[{c%s{g]\r\n\r\n", 
+ 		 olcGetArgument(olc));
+ 
+   // show all the scripts attached
+   while((script = listPop(scripts)) != NULL)
+     send_to_socket(sock,
+ 		   "  {y[{c%4d{y]{w %-20s {c%s\r\n",
+ 		   scriptGetVnum(script), 
+ 		   scriptTypeName(scriptGetType(script)),
+ 		   scriptGetName(script));
+   deleteList(scripts);
+ 
+   send_to_socket(sock,
+ 		 "\r\n"
+ 		 "{cA{g) add new script\r\n"
+ 		 "{cR{g) remove script\r\n"
+ 		 "\r\n"
+ 		 "Enter your choice (Q to quit) : ");
+ }
+ 
+ 
+ 
+ void ssedit_main_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   int next_substate = SSEDIT_MAIN;
+ 
+   switch(toupper(*arg)) {
+   case 'q':
+   case 'Q':
+     send_to_socket(sock, "Save changes (Y/N) : ");
+     next_substate = SSEDIT_CONFIRM_SAVE;
+     break;
+ 
+   case 'a':
+   case 'A':
+     send_to_socket(sock, "Which script would you like to add (-1 for none) : ");
+     next_substate = SSEDIT_ADD;
+     break;
+ 
+   case 'r':
+   case 'R':
+     send_to_socket(sock, "Which script would you like to remove (-1 for none) : ");
+     next_substate = SSEDIT_REMOVE;
+     break;
+ 
+   default:
+     ssedit_menu(sock, olc);
+     break;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+ }
+ 
+ 
+ void ssedit_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   SCRIPT_SET *set = (SCRIPT_SET *)olcGetData(olc);
+   int next_substate = SSEDIT_MAIN;
+ 
+   switch(olcGetSubstate(olc)) {
+     /******************************************************/
+     /*                     MAIN MENU                      */
+     /******************************************************/
+   case SSEDIT_MAIN:
+     ssedit_main_loop(sock, olc, arg);
+     return;
+ 
+ 
+     /******************************************************/
+     /*                    CONFIRM SAVE                    */
+     /******************************************************/
+   case SSEDIT_CONFIRM_SAVE:
+     switch(*arg) {
+     case 'y':
+     case 'Y':
+       olcSetSave(olc, TRUE);
+       // fall through
+     case 'n':
+     case 'N':
+       olcSetComplete(olc, TRUE);
+       return;
+     default:
+       send_to_socket(sock, "Please enter Y or N : ");
+       next_substate = SSEDIT_CONFIRM_SAVE;
+       break;
+     }
+     break;
+ 
+ 
+     /******************************************************/
+     /*                      SET VALUES                    */
+     /******************************************************/
+   case SSEDIT_ADD: {
+     // check to make sure the script exists
+     SCRIPT_DATA *script = worldGetScript(gameworld, atoi(arg));
+     if(script)
+       scriptSetAdd(set, scriptGetVnum(script)); 
+   }
+     break;
+ 
+   case SSEDIT_REMOVE:
+     scriptSetRemove(set, atoi(arg));
+     break;
+ 
+ 
+     /******************************************************/
+     /*                        DEFAULT                     */
+     /******************************************************/
+   default:
+     log_string("ERROR: Performing ssedit with invalid substate.");
+     send_to_socket(sock, "An error occured while you were in OLC.\r\n");
+     socketSetOLC(sock, NULL);
+     socketSetState(sock, STATE_PLAYING);
+     return;
+   }
+ 
+ 
+   /********************************************************/
+   /*                 DISPLAY NEXT MENU HERE               */
+   /********************************************************/
+   ssedit_menu(sock, olc);
+   olcSetSubstate(olc, next_substate);
+ }
+ 
+ #endif // MODULE_SCRIPTS
diff -crN nakedmudv1.0/src/olc/zedit.c nakedmudv1.4/src/olc/zedit.c
*** nakedmudv1.0/src/olc/zedit.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/olc/zedit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,148 ----
+ //*****************************************************************************
+ //
+ // zedit.c
+ //
+ // Contains all of the functions needed for online editing of zones.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../world.h"
+ #include "../zone.h"
+ #include "../socket.h"
+ #include "../utils.h"
+ 
+ #include "olc.h"
+ 
+ 
+ void zedit_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
+   ZONE_DATA *zone = (ZONE_DATA *)olcGetData(olc);
+ 
+   send_to_socket(sock,
+                  "\033[H\033[J"
+ 		 "{g[{c%d{g]\r\n"
+ 		 "{g1) Name\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g2) Editors\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g3) Reset timer: {c%d {gmins\r\n"
+ 		 "{g4) Description\r\n"
+ 		 "{c%s\r\n"
+ 		 "\r\n"
+ 		 "{gEnter choice (Q to quit) : {n",
+ 		 zoneGetVnum(zone),
+ 		 zoneGetName(zone),
+ 		 zoneGetEditors(zone),
+ 		 zoneGetPulseTimer(zone),
+ 		 zoneGetDesc(zone)
+ 		 );
+ }
+ 
+ 
+ void zedit_main_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   int next_substate = ZEDIT_MAIN;
+ 
+   switch(*arg) {
+   case 'q':
+   case 'Q':
+     send_to_socket(sock, "Save changes (Y/N) : ");
+     next_substate = ZEDIT_CONFIRM_SAVE;
+     break;
+ 
+   case '1':
+     send_to_socket(sock, "Enter new name : ");
+     next_substate = ZEDIT_NAME;
+     break;
+ 
+   case '2':
+     send_to_socket(sock, "Enter a new list of editors : ");
+     next_substate = ZEDIT_EDITORS;
+     break;
+ 
+   case '3':
+     send_to_socket(sock, "Enter reset timer (-1 for no resets) : ");
+     next_substate = ZEDIT_RESET;
+     break;
+ 
+   case '4':
+     send_to_socket(sock, "Enter new description\r\n");
+     start_text_editor(sock, 
+ 		      zoneGetDescPtr((ZONE_DATA *)olcGetData(olc)),
+ 		      MAX_BUFFER, EDITOR_MODE_NORMAL);
+     next_substate = ZEDIT_MAIN;
+     break;
+ 
+   default:
+     zedit_menu(sock, olc);
+     break;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+ }
+ 
+ 
+ 
+ void zedit_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   ZONE_DATA *zone = (ZONE_DATA *)olcGetData(olc);
+   int next_substate = ZEDIT_MAIN;
+ 
+   switch(olcGetSubstate(olc)) {
+     /******************************************************/
+     /*                     MAIN MENU                      */
+     /******************************************************/
+   case ZEDIT_MAIN:
+     zedit_main_loop(sock, olc, arg);
+     return;
+ 
+ 
+     /******************************************************/
+     /*                    CONFIRM SAVE                    */
+     /******************************************************/
+   case ZEDIT_CONFIRM_SAVE:
+     switch(*arg) {
+     case 'y':
+     case 'Y':
+       olcSetSave(olc, TRUE);
+       // fall through
+     case 'n':
+     case 'N':
+       olcSetComplete(olc, TRUE);
+       return;
+     default:
+       send_to_socket(sock, "Please enter Y or N : ");
+       next_substate = ZEDIT_CONFIRM_SAVE;
+       break;
+     }
+     break;
+ 
+ 
+     /******************************************************/
+     /*                      SET VALUES                    */
+     /******************************************************/
+   case ZEDIT_NAME:
+     zoneSetName(zone, arg);
+     break;
+ 
+   case ZEDIT_EDITORS:
+     zoneSetEditors(zone, arg);
+     break;
+ 
+   case ZEDIT_RESET:
+     zoneSetPulseTimer(zone, atoi(arg));
+     break;
+ 
+     /******************************************************/
+     /*                        DEFAULT                     */
+     /******************************************************/
+   default:
+     log_string("ERROR: Performing zedit with invalid substate.");
+     send_to_socket(sock, "An error occured while you were in OLC.\r\n");
+     socketSetOLC(sock, NULL);
+     socketSetState(sock, STATE_PLAYING);
+     return;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+   if(next_substate == ZEDIT_MAIN)
+     zedit_menu(sock, olc);
+ }
diff -crN nakedmudv1.0/src/races.c nakedmudv1.4/src/races.c
*** nakedmudv1.0/src/races.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/races.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 21,27 ****
  const struct race_data race_info[NUM_RACES] = {
    { "human", "hum",  BODYTYPE_HUMANOID, TRUE  },
    { "elf",   "elf",  BODYTYPE_HUMANOID, TRUE  },
!   { "dragon", "drg", BODYTYPE_DRAGON,  FALSE  }
  };
  
  bool raceIsForPC(int race) {
--- 21,27 ----
  const struct race_data race_info[NUM_RACES] = {
    { "human", "hum",  BODYTYPE_HUMANOID, TRUE  },
    { "elf",   "elf",  BODYTYPE_HUMANOID, TRUE  },
!   { "dragon","drg",  BODYTYPE_DRAGON,  FALSE  }
  };
  
  bool raceIsForPC(int race) {
diff -crN nakedmudv1.0/src/room.c nakedmudv1.4/src/room.c
*** nakedmudv1.0/src/room.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/room.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 1,9 ****
  //*****************************************************************************
  //
! // room.h
  //
! // the implementation of the room data structure, and its corresponding 
! // functions
  //
  //*****************************************************************************
  
--- 1,13 ----
  //*****************************************************************************
  //
! // room.c
  //
! // the basic implementation of the room data structure. If you plan on adding
! // any other information to rooms, it is strongly suggested you do so through
! // auxiliary data (see auxiliary.h)
! //
! // For a recap, IF YOU PLAN ON ADDING ANY OTHER INFORMATION TO ROOMS, IT
! // IS STRONGLY SUGGESTED YOU DO SO THROUGH AUXILIARY DATA (see auxiliary.h).
  //
  //*****************************************************************************
  
***************
*** 20,26 ****
  
  
  #ifdef MODULE_SCRIPTS
! #include "modules/scripts/script.h"
  #endif
  
  
--- 24,30 ----
  
  
  #ifdef MODULE_SCRIPTS
! #include "scripts/script.h"
  #endif
  
  
***************
*** 32,40 ****
  struct room_data {
    room_vnum   vnum;              // what vnum are we?
  
!   int   terrain;                 // what kind of terrain do we have?
!   char *name;                    // what is the name of our room?
!   char *desc;                    // our description
  
    EDESC_SET  *edescs;            // the extra descriptions in the room
    EXIT_DATA **exits;             // the normal exists
--- 36,44 ----
  struct room_data {
    room_vnum   vnum;              // what vnum are we?
  
!   int         terrain;           // what kind of terrain do we have?
!   char       *name;              // what is the name of our room?
!   char       *desc;              // our description
  
    EDESC_SET  *edescs;            // the extra descriptions in the room
    EXIT_DATA **exits;             // the normal exists
***************
*** 111,117 ****
      deleteHashIterator(hash_i);
    }
  
- 
    // delete strings
    if(room->name)        free(room->name);
    if(room->desc)        free(room->desc);
--- 115,120 ----
diff -crN nakedmudv1.0/src/room.h nakedmudv1.4/src/room.h
*** nakedmudv1.0/src/room.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/room.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 4,28 ****
  //
  // room.h
  //
! // the interface for working with the room structure.
  //
  //*****************************************************************************
  
! 
! 
! #define DIR_NONE       (-1)
! #define DIR_NORTH         0
! #define DIR_EAST          1
! #define DIR_SOUTH         2
! #define DIR_WEST          3
! #define DIR_UP            4
! #define DIR_DOWN          5
! #define DIR_NORTHEAST     6
! #define DIR_SOUTHEAST     7
! #define DIR_SOUTHWEST     8
! #define DIR_NORTHWEST     9
! #define NUM_DIRS         10
! 
  
  #define TERRAIN_NONE         (-1)
  #define TERRAIN_INDOORS         0	
--- 4,32 ----
  //
  // room.h
  //
! // the basic interface for working with the room structure.
! //
! // the basic interface for working with the room data structure. If you plan on
! // adding any other information to rooms, it is strongly suggested you do so
! // through auxiliary data (see auxiliary.h)
! //
! // For a recap, IF YOU PLAN ON ADDING ANY OTHER INFORMATION TO ROOMS, IT
! // IS STRONGLY SUGGESTED YOU DO SO THROUGH AUXILIARY DATA (see auxiliary.h).
  //
  //*****************************************************************************
  
! #define DIR_NONE             (-1)
! #define DIR_NORTH               0
! #define DIR_EAST                1
! #define DIR_SOUTH               2
! #define DIR_WEST                3
! #define DIR_UP                  4
! #define DIR_DOWN                5
! #define DIR_NORTHEAST           6
! #define DIR_SOUTHEAST           7
! #define DIR_SOUTHWEST           8
! #define DIR_NORTHWEST           9
! #define NUM_DIRS               10
  
  #define TERRAIN_NONE         (-1)
  #define TERRAIN_INDOORS         0	
***************
*** 35,54 ****
  #define TERRAIN_UNDERWATER	7	
  #define TERRAIN_FIELD           8	
  #define TERRAIN_PLAINS          9 
! #define TERRAIN_MEADOW          10
! #define TERRAIN_FOREST          11
! #define TERRAIN_DEEP_FOREST     12 
! #define TERRAIN_HILLS           13
! #define TERRAIN_HIGH_HILLS      14
! #define TERRAIN_MOUNTAIN        15
! #define TERRAIN_SWAMP           16 
! #define TERRAIN_DEEP_SWAMP      17
! #define TERRAIN_SAND            18 
! #define TERRAIN_DESERT          19
! #define TERRAIN_ICE             20
! #define TERRAIN_GLACIER         21
! #define TERRAIN_CAVERN          22
! #define NUM_TERRAINS            23
  
  
  //
--- 39,58 ----
  #define TERRAIN_UNDERWATER	7	
  #define TERRAIN_FIELD           8	
  #define TERRAIN_PLAINS          9 
! #define TERRAIN_MEADOW         10
! #define TERRAIN_FOREST         11
! #define TERRAIN_DEEP_FOREST    12 
! #define TERRAIN_HILLS          13
! #define TERRAIN_HIGH_HILLS     14
! #define TERRAIN_MOUNTAIN       15
! #define TERRAIN_SWAMP          16 
! #define TERRAIN_DEEP_SWAMP     17
! #define TERRAIN_SAND           18 
! #define TERRAIN_DESERT         19
! #define TERRAIN_ICE            20
! #define TERRAIN_GLACIER        21
! #define TERRAIN_CAVERN         22
! #define NUM_TERRAINS           23
  
  
  //
diff -crN nakedmudv1.0/src/scripts/module.mk nakedmudv1.4/src/scripts/module.mk
*** nakedmudv1.0/src/scripts/module.mk	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/scripts/module.mk	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,116 ----
+ ################################################################################
+ #
+ # Python scripting stuff.
+ #
+ # To embed python as a scripting language, you will probably have to toy around
+ # with the make process. Sadly, this process can be very different from computer
+ # to computer. I've tried to set the defaults to what I've seen to be the most
+ # common settings, but chances are you will have to tweak a couple things in
+ # this file. There are three variables in this makefile you will have to edit.
+ # They are PYTHONTOP, LIBS, and C_FLAGS. I'll try to walk you through 
+ # everything you'll need to do to get these variables all proper-like:
+ #
+ # STEP 1: Locating Python
+ #   Figure out where your python directory is. If you do not know how to do
+ #   this, you can do a "find" from your shell:
+ #     find / -name "Python.h" -print
+ #
+ #   wait for the path to Python.h to show up. You'll have to doctor it a bit;
+ #   from the path, you will want to figure out the top directory for python, and
+ #   where all of the header files are located. If the path looks something like:
+ #     /usr/lib/python2.4/include/Python.h
+ #
+ #   PYTHONTOP would be /usr/lib/python2.4
+ #   and C_FLAGS should include -I$(PYTHONTOP)/include
+ #
+ #   If you are not running Python v2.4 or newer, it is strongly suggested you
+ #   upgrade before continuing (see http://www.python.org).
+ #
+ #
+ # STEP 2: Getting the linking requirements for python.
+ #   This is a relatively easy step; start up python (from shell, type "python")
+ #   and do this:
+ #
+ #   >>> import distutils.sysconfig
+ #   >>> distutils.sysconfig.get_config_var('LINKFORSHARED')
+ #
+ #   a string will print that looks something like:
+ #   '-Xlinker -export-dynamic'
+ #
+ #   copy this string (minus the two surrounding ') to the LIBS variable at the
+ #   end of this makefile.
+ #
+ #
+ # STEP 3: Compiling
+ #   Try compiling. If you get a bunch of errors, go onto step 4.
+ #
+ #
+ # STEP 4: Finding the runtime library.
+ #   Some operating systems will require that you take extra steps to link in 
+ #   the python runtime library. This is the step people seem to be having most
+ #   trouble with, so you may want to pay special attention to this step. What
+ #   you are going to need to do is find the location of your python runtime 
+ #   library and add it to the LIBS variable like you did for the other 
+ #   libraries in step 2. Change your directory to PYTHONTOP and type:
+ #     find . -name "libpython*a" -print
+ #
+ #   When it spits out the address to the python library, add a string like this
+ #   to the LIBs variable at the bottom of this file:
+ #     -L/<path> -lpythonXXX
+ #
+ #   Where <path> is the path to the library (minus the library file itself), 
+ #   and XXX is the version number of your python. So, for instance, on my
+ #   computer, I had to add the following line to LIBS:
+ #     -L/usr/local/lib/python2.4/config -lpython2.4
+ #
+ #   If this is not working for you, there are other ways to link in the Python
+ #   runtime library. For instance, you might be able to simply add the whole
+ #   pathname of the library to your LIBS variable. The above example would
+ #   translate into:
+ #     /usr/local/lib/python2.4/config/libpython2.4.a
+ #
+ #   There are many ways to skin this cat. Google should be able to provide you
+ #   with a couple others if these two are not working for you. I would also be
+ #   more than willing to assist you if you are running into problems.
+ #
+ #   At this point, you should attempt to compile your code. If you are still
+ #   getting errors, move on to step 5.
+ #
+ # 
+ # STEP 5: Adding more libraries.
+ #   Still won't compile? You may need to add some extra libraries that Python
+ #   requires. These are usually quite easy to find; if you are getting messages
+ #   messages like "undefined references to sin", "undefined reference to
+ #   pthread_start" etc... you will want to add the libraries that these 
+ #   functions belong to. for each one that comes up, do a "man XXX" and read
+ #   the man file until you figure out which library the function belongs to.
+ #   Ones that I found were neccessary for me to include on Fedora were -lm,
+ #   -lutil and -ldl . This, of course, will vary from OS to OS. Add all of the
+ #   libraries you need to the end of LIBS, where you put the libraries from
+ #   STEP 2. Try Recompiling. If things still aren't working for you, proceed
+ #   to STEP 6. If things ARE working, I would really appreciate an email
+ #   describing what your module.mk ended up looking like, and what operating
+ #   system you use. Help save the next NakedMud user from going through all of
+ #   the arduous work you just did!
+ #
+ #
+ # STEP 6: On your own
+ #   If you've gotten to this step, I don't really have much more to say. I 
+ #   would suggest finding some Python BBs and explaining your problem. Perhaps
+ #   someone a bit more experienced will be able to help out.
+ #
+ ################################################################################
+ 
+ # Object files we generate
+ SRC      += scripts/script_set.c scripts/script.c scripts/pychar.c \
+ 	    scripts/pyobj.c scripts/pymud.c scripts/pyroom.c \
+ 	    scripts/script_editor.c scripts/script_edit.c
+ 
+ # the top level directory of python
+ PYTHONTOP = /usr/local/include
+ 
+ # the folder where python headers are located
+ C_FLAGS  += -I$(PYTHONTOP)/python2.4
+ 
+ # libraries we have to include
+ LIBS     += -Xlinker -export-dynamic -lm -ldl -lutil -L/usr/local/lib/python2.4/config -lpython2.4
